Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /config/releases/release-110.63/install.sh
ViewVC logotype

Diff of /config/releases/release-110.63/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 489, Tue Nov 23 12:55:00 1999 UTC revision 1038, Mon Jan 28 00:18:03 2002 UTC
# Line 2  Line 2 
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4  #  #
5  # installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
6  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
7  #  #
8    # Significant changes to accommodate (and take advantage of) the new CM
9    # by M.Blume (2/2000).
10    #
11    
12  #set -x  this=$0
13    
14  #  #
15  # get the target list  # get the target list
16  #  #
17  if [ ! -r config/targets ]; then  if [ -r config/targets.customized ] ; then
18    echo "!!! File config/targets is missing."      . config/targets.customized
19    exit 1;  elif [ ! -r config/targets ]; then
20  fi      echo "$this: !!! File config/targets is missing."
21        exit 1
22    else
23  . config/targets  . config/targets
24    fi
25    
26  #  #
27  # some OSs have make in strange places  # create the preloads.standard file
28  #  #
29  MAKE=make  if [ ! -r config/preloads ]; then
30        echo "$this: !!! File config/preloads is missing."
31        exit 1
32    fi
33    cp config/preloads preloads.standard
34    
35  #  #
36  # check for ksh  # Some OSs have make in strange places, but most of the time it is
37    # simply on the PATH:
38  #  #
39  # ksh causes some people problems so we will always use /bin/sh  MAKE=make
40    
41  #  #
42  #echo "checking for ksh"  # Make sure we don't have any unpleasant surprises due to the installing
43  #if [ -x /bin/ksh ]; then  # user's process environment:
44  #  SHELL=/bin/ksh  #
45  #elif [ -x /usr/local/bin/ksh ]; then  unset CM_PATHCONFIG
46  #  SHELL=/usr/local/bin/ksh  
 #else  
47    SHELL=/bin/sh    SHELL=/bin/sh
48  #fi  echo $this: Using shell $SHELL.
 echo Using shell $SHELL.  
49    
50  #  #
51  # set the SML root directory  # set the SML root directory
52  #  #
53  REAL_PWD=`pwd`  REAL_PWD=`pwd`
54  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
55  echo SML root is $ROOT.  echo $this: SML root is $ROOT.
56  echo Installation directory is ${INSTALLDIR:=$ROOT}.  echo $this: Installation directory is ${INSTALLDIR:=$ROOT}.
57    
58  #  #
59  # set the various directory and file pathname variables  # set the various directory and file pathname variables
# Line 55  Line 65 
65  SRCDIR=$ROOT/src                # where the source tree is rooted  SRCDIR=$ROOT/src                # where the source tree is rooted
66  LIBDIR=$INSTALLDIR/lib          # where libraries live  LIBDIR=$INSTALLDIR/lib          # where libraries live
67  LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries  LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries
68    LATESTANDALONES=$ROOT/latestandalones # standalone programs to be built late
69  LIBMOVESCRIPT=$ROOT/libmove     # a temporary script  LIBMOVESCRIPT=$ROOT/libmove     # a temporary script
70  LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file  LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file
71    
72    URLGETTER=unknown
73    
74    #
75    # The path to the dir where ml-yacc, ml-burg, ml-lex, ml-build, and
76    # ml-makedepend live.  This path will be interpreted relative to $LIBDIR.
77    #
78    TOOLDIR=../bin
79    
80    #
81    # A temporary file for post-editing the pathconfig file...
82    #
83    PCEDITTMP=$INSTALLDIR/pcedittmp.$$
84    
85    #
86    # files to be deleted after we are done...
87  #  #
88  # the paths to ml-yacc, ml-burg, and ml-lex; needed to configure CM  tmpfiles=""
89    tmpfiles="$tmpfiles $ROOT/preloads.standard"
90    tmpfiles="$tmpfiles $LIBLIST"
91    tmpfiles="$tmpfiles $LATESTANDALONES"
92    tmpfiles="$tmpfiles $LOCALPATHCONFIG"
93    tmpfiles="$tmpfiles $LIBMOVESCRIPT"
94    tmpfiles="$tmpfiles $PCEDITTMP"
95  #  #
96  YACCPATH=$BINDIR/ml-yacc  # make sure we always clean up after ourselves...
97  LEXPATH=$BINDIR/ml-lex  #
98  BURGPATH=$BINDIR/ml-burg  trap 'rm -f $tmpfiles' 0 1 2 3 15
99    
100    
101  #  #
102  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
103  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
104  # Especially important is CM_PATHCONFIG_DEFAULT.  # Especially important is CM_PATHCONFIG_DEFAULT.
105  #  #
 CM_YACC_DEFAULT=$YACCPATH  
 CM_LEX_DEFAULT=$LEXPATH  
 CM_BURG_DEFAULT=$BURGPATH  
106  CM_PATHCONFIG_DEFAULT=$LIBDIR/pathconfig  CM_PATHCONFIG_DEFAULT=$LIBDIR/pathconfig
107  export CM_YACC_DEFAULT CM_LEX_DEFAULT CM_BURG_DEFAULT CM_PATHCONFIG_DEFAULT  export CM_PATHCONFIG_DEFAULT
108    
109  #  #
110  # the release version that we are installing  # the release version that we are installing
111  #  #
112  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat $CONFIGDIR/version`
113  echo Installing version $VERSION.  echo $this: Installing version $VERSION.
114    
115  #  #
116  # Function to make a directory (and advertise such action).  # the URL for the (usually remote) source archive
117    #
118    SRCARCHIVEURL=`cat $CONFIGDIR/srcarchiveurl`
119    echo $this: URL of source archive is $SRCARCHIVEURL.
120    
121    #
122    # Function to make a directory including its ancestors.
123  #  #
124  makedir() {  makedir() {
125      if [ ! -d $1 ] ; then      if [ x$1 = x ] ; then
126          echo Making directory $1          :
127        elif [ -d $1 ] ; then
128            :
129        else
130            makedir `dirname $1`
131            echo "$this: Making directory $1"
132          if mkdir $1 ; then          if mkdir $1 ; then
133              : everything is fine              :
134          else          else
135              echo "!!! Unable to make directory $1!"              echo "$this: !!! Unable to make directory $1!"
136                exit 1
137            fi
138        fi
139    }
140    
141    #
142    # Function for asking user to fetch source archive.
143    #   $1 - descriptive name
144    #   $2 - base name without extension, without version, and without dir
145    #   $3 - remote directory
146    #
147    askurl() {
148        echo "$this: Please, fetch $1 archive"
149        echo ' ('$2.'*' or $VERSION-$2.'*)'
150        echo " from $3"
151        echo " and then re-run this script!"
152              exit 1              exit 1
153    }
154    
155    #
156    # Function for fetching source archives automatically using wget or lynx.
157    #   $1 - command to actually get the stuff
158    #   $2 - descriptive name
159    #   $3 - base name without extension and without dir
160    #   $4 - remote directory
161    #
162    fetchurl() {
163        getter=$1 ; shift
164        echo $this: Fetching $1 from $3. Please stand by...
165        fetched=no
166        for base in $2 $VERSION-$2 ; do
167            for ext in tar.gz tgz tar.Z tz tar tar.bz2 ; do
168                try=$base.$ext
169                echo $this: Trying $try ...
170                if $getter $3 $try $ROOT/$try ; then
171                    fetched=yes
172                    echo $this: Fetching $try was a success.
173                    break 2         # get out of both for-loops
174                else
175                    rm -f $ROOT/$try
176                fi
177            done
178        done
179        if [ $fetched = no ] ; then
180            echo $this: Fetching $try was no success.
181            echo '  ' You should try to do it manually now.
182            askurl "$1" "$2" "$3"
183        fi
184    }
185    
186    usewget() {
187        wget -nv -O $3 $1/$2
188    }
189    
190    uselynx() {
191        lynx -source $1/$2 >$3
192    }
193    
194    usecurl() {
195        curl -s $1/$2 >$3
196    }
197    
198    testurlgetter() {
199        (exec >/dev/null 2>&1 ; exec $*)
200    }
201    
202    #
203    # Function to check whether wget or lynx is available.
204    # Set URLGETTER accordingly.
205    #
206    urlgetter() {
207        if [ "$URLGETTER" = unknown ] ; then
208            if testurlgetter wget --help ; then
209                URLGETTER="fetchurl usewget"
210            elif testurlgetter curl --help ; then
211                URLGETTER="fetchurl usecurl"
212            elif testurlgetter lynx -help ; then
213                URLGETTER="fetchurl uselynx"
214            else
215                URLGETTER="askurl"
216            fi
217          fi          fi
218    }
219    
220    un_tar() {
221        echo "$this: Un-TAR-ing $1 archive."
222        tar -xf $2
223    }
224    
225    un_tar_Z() {
226        echo "$this: Un-COMPRESS-ing and un-TAR-ing $1 archive."
227        zcat $2 | tar -xf -
228    }
229    
230    un_tar_gz() {
231        echo "$this: Un-GZIP-ing and un-TAR-ing $1 archive."
232        gunzip -c $2 | tar -xf -
233    }
234    
235    un_tar_bz2() {
236        echo "$this: Un-BZIP2-ing and un-TAR-ing $1 archive."
237        bunzip2 -c $2 | tar -xf -
238    }
239    
240    unarchive() {
241        # $1: descriptive string, $2: archive, $3: unpacker
242        if [ -r $ROOT/$2 ] ; then
243            $3 "$1" $ROOT/$2
244        elif [ -r $ROOT/$VERSION-$2 ]; then
245            $3 "$1" $ROOT/$VERSION-$2
246        else
247            return 1
248      fi      fi
249  }  }
250    
# Line 106  Line 257 
257  # $4: the basename of the source archive (the script will check several  # $4: the basename of the source archive (the script will check several
258  #     different suffixes to determine what kind of de-compression is to  #     different suffixes to determine what kind of de-compression is to
259  #     be used)  #     be used)
260  unpack() {  #
261      if [ ! -d $2/$3 ]; then  # fetch_n_unpack is the helper function that does the real work.  If
262          echo Unpacking $1 source files.  # no archive is found locally, it invokes $URLGETTER and tries again.
263    # The variable $tryfetch is used to make sure this happens only once.
264    fetch_n_unpack() {
265          cd $2          cd $2
266          if [ -r $4.tar.Z ] ; then      if unarchive "$1" $4.tar.gz un_tar_gz ||
267              zcat $4.tar.Z | tar -xf -         unarchive "$1" $4.tgz un_tar_gz ||
268          elif [ -r $4.tar ] ; then         unarchive "$1" $4.tar.Z un_tar_Z ||
269              tar -xf $4.tar         unarchive "$1" $4.tar un_tar ||
270          elif [ -r $4.tar.gz ] ; then         unarchive "$1" $4.tar.bz1 un_tar_bz2 ||
271              gunzip -c $4.tar.gz | tar -xf -         unarchive "$1" $4.tz un_tar_Z
272          elif [ -r $4.tar.bz2 ] ; then      then
273              bunzip2 -c $4.tar.bz2 | tar -xf -          : we are done
274          elif [ -r $4.tgz ] ; then      elif [ $tryfetch = yes ] ; then
275              gunzip -c $4.tgz | tar -xf -          urlgetter
276          elif [ -r $4.tz ] ; then          $URLGETTER "$1" $4 $SRCARCHIVEURL
277              zcat $4.tz | tar -xf -          tryfetch=no
278            fetch_n_unpack "$1" "$2" "$3" "$4"
279        fi
280    }
281    
282    #
283    # The main "unpack" driver function that invokes the above helper.
284    #
285    unpack() {
286        tryfetch=yes
287        if [ -d $2/$3 ]; then
288            echo "$this: The $1 tree already exists."
289          else          else
290              echo "!!! The $1 source files are missing."          fetch_n_unpack "$1" "$2" "$3" "$4"
             exit 1  
291          fi          fi
292          if [ ! -d $2/$3 ]; then          if [ ! -d $2/$3 ]; then
293              echo "!!! Unable to unpack $1 source files."          echo "$this: !!! Unable to unpack $1 archive."
294              exit 1              exit 1
295          fi          fi
     fi  
296  }  }
297    
298  #  # A function to move all stable library files to a parallel directory
299  # Move the stable archive of a library whose description file was $1/$2 to  # hierarchy.
300  # $LIBDIR/$2/CM/$ARCH-unix/$2 so that it appears as if the description file  # The first argument must be a simple path (no / inside), and
301  # had been at $LIBDIR/$2/$2  # the second argument must be an absolute path.
302  #  move() {
303  # (This script will also move all other libraries that show up in      if [ -d $1 ] ; then
304  #  $1/CM/$ARCH-unix because in the case of the boot directory this indicates          if [ ! -d $2 ] ; then
305  #  that some library did not have its own path anchor but was specified              if [ -f $2 ] ; then
306  #  relative to $1/$2. Still, don't rely on this to be robust -- rather make                  echo $this: $2 exists as a non-directory.
307  #  separate anchors for every library!)                  exit 1
 #  
 movelibs() {  
     for lib in `/bin/ls $1/CM/$ARCH-unix` ; do  
         case $lib in  
         *.cm)  
             if [ $lib != $2 ] ; then  
                 echo "! Warning:" $lib specified relative to $2  
308              fi              fi
309              echo Moving library $lib to $LIBDIR              mkdir $2
310              makedir $LIBDIR/$2          fi
311              makedir $LIBDIR/$2/CM          cd $1
312              makedir $LIBDIR/$2/CM/$ARCH-unix          for i in * ; do
313              mv $1/CM/$ARCH-unix/$lib $LIBDIR/$2/CM/$ARCH-unix/$lib              move $i $2/$i
             ;;  
         *)  
             ;;  
         esac  
314       done       done
315            cd ..
316        elif [ -f $1 ] ; then
317            rm -f $2
318            mv $1 $2
319        fi
320    }
321    
322    # move stable library file from $1 to $2
323    movelib()
324    {
325        SOURCE=$1
326        TARGET=$2
327        TARGETDIR=`dirname ${TARGET}`
328        if [ ! -d ${TARGETDIR} ] ; then
329            makedir ${TARGETDIR}
330        fi
331        mv ${SOURCE} ${TARGET}
332  }  }
333    
334  # A shell function that registers a library for being built.  # A shell function that registers a library for being built.
335  # This function takes two arguments: 1. a name under which the library  # This function takes 3 arguments:
336  # is to be known later (something.cm) and 2. the path relative to $SRCDIR  #   $1 = controlling anchor
337  # that leads to the library's .cm file.  The library's .cm file must be the  #   $2 = name relative to controlling anchor
338  # same as $1.  #   $3 = dir (relative to ${SRCDIR}) corresponding to $1
339  #  #
340  # This works by adding ML code to file $LIBLIST.  The code in this file  # This works by adding ML code to file $LIBLIST.  The code in this file
341  # will be executed near the end of this script.  If $MOVE_LIBRARIES is  # will be executed near the end of this script.  If $MOVE_LIBRARIES is
342  # set to true, then reglib will also register a "movelibs" to be executed at  # set to true, then reglib will also register a "movelib" to be executed at
343  # the end by putting a "movelibs" line into $LIBMOVESCRIPT.  # the end by putting a "movelib" line into $LIBMOVESCRIPT.
   
344  reglib() {  reglib() {
345        ANCHOR=$1
346        RELNAME=$2
347        LIBNAME='$'${ANCHOR}/${RELNAME}
348        ADIR=${SRCDIR}/$3
349        RELDIR=`dirname $RELNAME`
350        RELBASE=`basename $RELNAME`
351        if [ x$RELDIR = x. ] ; then
352            RELDIR=
353        else
354            RELDIR=/$RELDIR
355        fi
356        RELLOC=${RELDIR}/CM/${ARCH}-unix/${RELBASE}
357        SRCFINALLOC=${ADIR}${RELLOC}
358      if [ x$MOVE_LIBRARIES = xtrue ] ; then      if [ x$MOVE_LIBRARIES = xtrue ] ; then
359          FINALLOCATION=$LIBDIR/$1          FINALLOC=${LIBDIR}/${ANCHOR}${RELLOC}
360            FINALCONFIGPATH=${ANCHOR}
361      else      else
362          FINALLOCATION=$SRCDIR/$2          FINALLOC=${SRCFINALLOC}
363            FINALCONFIGPATH=${ADIR}
364      fi      fi
365      if [ -d $FINALLOCATION/CM/$ARCH-unix ] ; then  
366          echo "Library $1 already exists in $FINALLOCATION."      if [ -f ${FINALLOC} ] ; then
367            echo "$this: Library ${LIBNAME} already exists in ${FINALLOC}"
368      else      else
369          echo "Scheduling library $1 to be built in $FINALLOCATION."          echo "$this: Scheduling library ${LIBNAME} to be built as ${FINALLOC}."
370          echo "andalso CM.stabilize false \"$1\"" >>$LIBLIST          echo "  andalso CM.stabilize false \"${LIBNAME}\"" >>${LIBLIST}
371          echo $1 $SRCDIR/$2 >>$LOCALPATHCONFIG          echo ${ANCHOR} ${ADIR} >>${LOCALPATHCONFIG}
372          if [ x$MOVE_LIBRARIES = xtrue ] ; then          if [ x$MOVE_LIBRARIES = xtrue ] ; then
373              echo movelibs $SRCDIR/$2 $1 >>$LIBMOVESCRIPT              echo movelib ${SRCFINALLOC} ${FINALLOC} >>${LIBMOVESCRIPT}
374          fi          fi
         echo $1 $FINALLOCATION >>$CM_PATHCONFIG_DEFAULT  
375      fi      fi
376        echo ${ANCHOR} ${FINALCONFIGPATH} >>${CM_PATHCONFIG_DEFAULT}
377  }  }
378    
379  #  #
380  # Function to build a standalone program such as ml-yacc.  The function takes  # Function to build a standalone program such as ml-yacc.  The function takes
381  # 2 or 3 arguments.  First the name of the program which at the same time  # 2 or 3 or 4 arguments.  First the name of the program which at the same time
382  # is the directory name under $SRCDIR where the sources reside.  The second  # is the directory name under $SRCDIR/$4 where the sources reside.  The second
383  # argument is a descriptive name for the program (passed on to "unpack").  # argument is a descriptive name for the program (passed on to "unpack").
384  # The optional third argument specifies the path relative to $SRCDIR/$1  # The optional third argument specifies the path relative to $SRCDIR/$4/$1
385  # of the directory where the program's heap image is to be found.  # of the directory where the program's heap image is to be found.
386    # The fourth argument, if missing, defaults to "."
387  #  #
388    
389  standalone() {  standalone() {
# Line 209  Line 393 
393      else      else
394          TARGETLOC=$TARGET          TARGETLOC=$TARGET
395      fi      fi
396        if [ $# = 4 ] ; then
397             MYSRCDIR=$SRCDIR/$4
398        else
399             MYSRCDIR=$SRCDIR
400        fi
401      if [ -r $HEAPDIR/$TARGET ] ; then      if [ -r $HEAPDIR/$TARGET ] ; then
402          echo Target $TARGET already exists.          echo $this: Target $TARGET already exists.
403      else      else
404          echo Building $TARGET.          echo $this: Building $TARGET.
405          unpack $2 $SRCDIR $1 $ROOT/$VERSION-$1          unpack $2 $MYSRCDIR $1 $1
406          cd $SRCDIR/$1          cd $MYSRCDIR/$1
407          ./build          # build it, but make sure we don't pick up some (unrelated)
408            # local path configuration...
409            CM_LOCAL_PATHCONFIG=/dev/null ./build
410          if [ -r $TARGETLOC ] ; then          if [ -r $TARGETLOC ] ; then
411              mv $TARGETLOC $HEAPDIR/$TARGET              mv $TARGETLOC $HEAPDIR/$TARGET
412              if [ ! -f $BINDIR/$1 ] ; then              if [ ! -f $BINDIR/$1 ] ; then
# Line 223  Line 414 
414                  ln -s .run-sml $1                  ln -s .run-sml $1
415              fi              fi
416          else          else
417              echo "!!! Build of $TARGET failed."              echo "$this: !!! Build of $TARGET failed."
418          fi          fi
419      fi      fi
420  }  }
# Line 231  Line 422 
422  #  #
423  # create the various sub directories  # create the various sub directories
424  #  #
425  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR ; do
 do  
426      makedir $dir      makedir $dir
427  done  done
428    
   
429  #  #
430  # install the script that tests the architecture, and make sure that it works  # install the script that tests the architecture, and make sure that it works
431  #  #
432  if [ -x $BINDIR/.arch-n-opsys ]; then  if [ -x $BINDIR/.arch-n-opsys ]; then
433    echo Script $BINDIR/.arch-n-opsys already exists.      echo $this: Script $BINDIR/.arch-n-opsys already exists.
434  else  else
435    cat $CONFIGDIR/_arch-n-opsys | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys      cat $CONFIGDIR/_arch-n-opsys \
436        | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys
437    chmod 555 $BINDIR/.arch-n-opsys    chmod 555 $BINDIR/.arch-n-opsys
438    if [ ! -x $BINDIR/.arch-n-opsys ]; then    if [ ! -x $BINDIR/.arch-n-opsys ]; then
439      echo "!!! Installation of $BINDIR/.arch-n-opsys failed for some reason."          echo "$this: !!! Installation of $BINDIR/.arch-n-opsys failed."
440      exit 1      exit 1
441    fi    fi
442  fi  fi
443    
444  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`
445  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
446    echo "!!! Script $BINDIR/.arch-n-opsys fails on this machine."      echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
447    echo "!!! You must patch this by hand and repeat the installation."      echo "$this: !!! You must patch this by hand and repeat the installation."
448    exit 2    exit 2
449  else  else
450    echo Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.      echo $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
451  fi  fi
452  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
453    
454  if [ -x $BINDIR/.run-sml ]; then  #
455    echo Script $BINDIR/.run-sml already exists.  # Function to install a "driver" script...
456  else  #   This takes care of patching the source of the script with the SHELL,
457    cat $CONFIGDIR/_run-sml | \  #   BINDIR, and VERSION variables to use.
458      sed -e "s,@SHELL@,$SHELL,g" -e "s,@BINDIR@,$BINDIR," -e "s,@VERSION@,$VERSION," \  #
459      > $BINDIR/.run-sml  installdriver() {
460    chmod 555 $BINDIR/.run-sml      dsrc=$1
461    if [ ! -x $BINDIR/.run-sml ]; then      ddst=$2
462      echo "!!! Installation of $BINDIR/.run-sml failed for some reason."  # We install the driver unconditionally. (It would be better to test
463    # for an outdated driver script, but not all "test" commands understand
464    # the -nt comparison operator....)
465    #   if [ -x $BINDIR/$ddst ]; then
466    #       echo $this: Script $BINDIR/$ddst already exists.
467    #   else
468            rm -f $BINDIR/$ddst
469            cat $CONFIGDIR/$dsrc | \
470            sed -e "s,@SHELL@,$SHELL,g" \
471                -e "s,@BINDIR@,$BINDIR," \
472                -e "s,@VERSION@,$VERSION," \
473                > $BINDIR/$ddst
474            chmod 555 $BINDIR/$ddst
475            if [ ! -x $BINDIR/$ddst ]; then
476                echo "$this: !!! Installation of $BINDIR/${ddst} failed."
477      exit 1      exit 1
478    fi    fi
479  fi  #   fi
480    }
481    
482    installdriver _run-sml .run-sml
483    installdriver _link-sml .link-sml
484    installdriver _ml-build ml-build
485    installdriver _ml-makedepend ml-makedepend
486    
487  #  #
488  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
489  #  #
490  case $ARCH in  case $ARCH in
491    mips*) ALLOC=1M ;;      mips*)
492            ALLOC=1M
493            ;;
494    x86)    x86)
495            # The following is the _wrong_ value for many popular x86 chips
496            # (i.e., Celerons).  However, the optimal value for those is 32k,
497            # and such a small value is not enough for the runtime system's boot
498            # code.  Therefore, we use 256k here and re-set it to the proper
499            # value in .run-sml.
500      ALLOC=256k      ALLOC=256k
501    ;;    ;;
502    alpha32)    alpha32)
# Line 288  Line 506 
506      ALLOC=512k      ALLOC=512k
507    ;;    ;;
508  esac  esac
509    
510  case $OPSYS in  case $OPSYS in
511    solaris)    solaris)
512      MAKE=/usr/ccs/bin/make      MAKE=/usr/ccs/bin/make
# Line 295  Line 514 
514    linux)    linux)
515      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
516      if [ "$?" != "0" ]; then      if [ "$?" != "0" ]; then
517        echo "!!! Problems checking for underscores in global names."              echo "$this: !!! Problems checking for underscores in asm names."
518        exit 1        exit 1
519      fi      fi
520      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
# Line 305  Line 524 
524  #  #
525  # the name of the bin files directory  # the name of the bin files directory
526  #  #
527  BOOT_FILES=comp.boot.$ARCH-unix  BOOT_ARCHIVE=boot.$ARCH-unix
528    BOOT_FILES=sml.$BOOT_ARCHIVE
529    
530  #  #
531  # build the run-time system  # build the run-time system
532  #  #
533  unpack "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime  unpack "run-time" $SRCDIR runtime runtime
534  if [ ! -x $RUNDIR/run.$ARCH-$OPSYS ]; then  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then
535        echo $this: Run-time system already exists.
536    else
537    cd $SRCDIR/runtime/objs    cd $SRCDIR/runtime/objs
538    echo Compiling the run-time system.      echo $this: Compiling the run-time system.
539    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
540    if [ -x run.$ARCH-$OPSYS ]; then    if [ -x run.$ARCH-$OPSYS ]; then
541      mv run.$ARCH-$OPSYS $RUNDIR      mv run.$ARCH-$OPSYS $RUNDIR
542      # $MAKE MAKE=$MAKE clean          $MAKE MAKE=$MAKE clean
543    else    else
544      echo "!!! Run-time system build failed for some reason."          echo "$this: !!! Run-time system build failed for some reason."
545      exit 1      exit 1
546    fi    fi
547  fi  fi
# Line 329  Line 551 
551  # boot the base SML system  # boot the base SML system
552  #  #
553  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then
554    echo Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.      echo $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
555  else  else
556    unpack bin $ROOT $BOOT_FILES $ROOT/$VERSION-$BOOT_FILES      unpack bin $ROOT $BOOT_FILES $BOOT_ARCHIVE
557    cd $ROOT      cd $ROOT/$BOOT_FILES
558    if $RUNDIR/run.$ARCH-$OPSYS @SMLheap=sml \      if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
         @SMLboot=$ROOT/$BOOT_FILES @SMLrtpid=`cat $BOOT_FILES/RTPID` \  
         @SMLalloc=$ALLOC  
559    then    then
560            cd $ROOT
561      if [ -r sml.$HEAP_SUFFIX ]; then      if [ -r sml.$HEAP_SUFFIX ]; then
562          mv sml.$HEAP_SUFFIX $HEAPDIR          mv sml.$HEAP_SUFFIX $HEAPDIR
563          cd $BINDIR          cd $BINDIR
564          ln -s .run-sml sml          ln -s .run-sml sml
   
565          #          #
566          # Now move all stable libraries to #LIBDIR and generate          # Now move all stable libraries to #LIBDIR and generate
567          # the pathconfig file.          # the pathconfig file.
568          #          #
   
569          cd $ROOT/$BOOT_FILES          cd $ROOT/$BOOT_FILES
570          for lib in *.cm ; do              for anchor in * ; do
571              echo $lib $LIBDIR/$lib >>$CM_PATHCONFIG_DEFAULT                  if [ -d $anchor ] ; then
572              movelibs $ROOT/$BOOT_FILES/$lib $lib                      echo $anchor $anchor >>$CM_PATHCONFIG_DEFAULT
573                        move $anchor $LIBDIR/$anchor
574                    fi
575          done          done
576          cd $ROOT          cd $ROOT
577          # rm -rf $BOOT_FILES              # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
578                rm -rf $BOOT_FILES
579    
580      else      else
581          echo "!!! Boot code did not produce heap image (sml.$HEAP_SUFFIX)."              echo "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
582          exit 1          exit 1
583      fi      fi
584    else    else
585      echo "!!! Boot code failed, no heap image built (sml.$HEAP_SUFFIX)."          echo "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
586      exit 1      exit 1
587    fi    fi
588  fi  fi
# Line 370  Line 592 
592  #  #
593  cd $ROOT  cd $ROOT
594  rm -f $LOCALPATHCONFIG $LIBLIST  rm -f $LOCALPATHCONFIG $LIBLIST
595  echo 'OS.Process.exit (if true' >$LIBLIST  echo 'ignore (OS.Process.exit (if true' >$LIBLIST
596    
597  #  #
598  # now build (or prepare to build) the individual targets  # now build (or prepare to build) the individual targets
599  #  #
600  cd $SRCDIR  cd $SRCDIR
601  echo Installing other targets.  echo $this: Installing other targets.
602  for i in $TARGETS ; do  for i in $TARGETS ; do
603      case $i in      case $i in
604        src-smlnj)        src-smlnj)
605          for src in compiler comp-lib cm MLRISC smlnj-lib ml-yacc system          for src in compiler cm MLRISC smlnj-lib ml-yacc system
606          do          do
607              unpack $src $ROOT/src $src $ROOT/$VERSION-$src              unpack $src $ROOT/src $src $src
608          done          done
609          ;;          ;;
610        ml-yacc)        ml-yacc)
611          standalone ml-yacc ML-Yacc src          standalone ml-yacc ML-Yacc src
612            echo ml-yacc $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
613          ;;          ;;
614        ml-lex)        ml-lex)
615          standalone ml-lex ML-Lex          standalone ml-lex ML-Lex
616            echo ml-lex $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
617          ;;          ;;
618        ml-burg)        ml-burg)
619          standalone ml-burg ML-Burg          standalone ml-burg ML-Burg
620            echo ml-burg $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
621            ;;
622          ml-nlffigen)
623            echo standalone ml-nlffigen ML-NLFFI-Gen >>$LATESTANDALONES
624            echo ml-nlffigen $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
625          ;;          ;;
626        smlnj-lib)        smlnj-lib)
627          unpack "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib          unpack "SML/NJ Library" $SRCDIR smlnj-lib smlnj-lib
628    
629          # Don't make the Util library -- it came pre-made and has been          # Don't make the Util library -- it came pre-made and has been
630          # installed when making the base system.  In other words, don't do...          # installed when making the base system.  In other words, don't do...
631              #reglib smlnj-lib.cm smlnj-lib/Util              #reglib smlnj-lib.cm smlnj-lib.cm smlnj-lib/Util
632            # ... and don't make the HTML library ...
633                #reglib html-lib.cm html-lib.cm smlnj-lib/HTML
634            # ... and don't make the PP library ...
635                #reglib pp-lib.cm pp-lib.cm smlnj-lib/PP
636          # make the Unix library          # make the Unix library
637              reglib unix-lib.cm smlnj-lib/Unix              reglib unix-lib.cm unix-lib.cm smlnj-lib/Unix
638          # make the INet library          # make the INet library
639              reglib inet-lib.cm smlnj-lib/INet              reglib inet-lib.cm inet-lib.cm smlnj-lib/INet
         # make the HTML library  
             reglib html-lib.cm smlnj-lib/HTML  
         # make the PP library  
             reglib pp-lib.cm smlnj-lib/PP  
640          # make the RegExp library          # make the RegExp library
641              reglib regexp-lib.cm smlnj-lib/RegExp              reglib regexp-lib.cm regexp-lib.cm smlnj-lib/RegExp
642          # make the Reactive library          # make the Reactive library
643              reglib reactive-lib.cm smlnj-lib/Reactive              reglib reactive-lib.cm reactive-lib.cm smlnj-lib/Reactive
644          ;;          ;;
645        cml)        cml)
646          unpack CML $SRCDIR cml $ROOT/$VERSION-cml          unpack CML $SRCDIR cml cml
647          reglib core-cml.cm cml/src/core-cml          reglib cml core-cml.cm cml/src
648          reglib cml.cm cml/src          reglib cml cml-internal.cm cml/src
649          reglib cml-basis.cm cml          reglib cml cml.cm cml/src
650            reglib cml basis.cm cml/src
651          ;;          ;;
652        cml-lib)        cml-lib)
653          unpack CML $SRCDIR cml $ROOT/$VERSION-cml          unpack CML $SRCDIR cml cml
654          reglib cml-lib.cm cml/cml-lib          reglib cml-lib trace-cml.cm cml/cml-lib/cm
655            reglib cml-lib smlnj-lib.cm cml/cml-lib/cm
656          ;;          ;;
657        eXene)        eXene)
658          unpack EXene $SRCDIR eXene $ROOT/$VERSION-eXene          unpack EXene $SRCDIR eXene eXene
659          reglib eXene.cm eXene          reglib eXene.cm eXene.cm eXene
660            ;;
661          ckit)
662            unpack "C-Kit" $ROOT ckit ckit
663            reglib ckit-lib.cm ckit-lib.cm ../ckit/src
664            ;;
665          ml-nlffi-lib)
666            unpack "NLFFI Library" $SRCDIR ml-nlffi-lib ml-nlffi-lib
667            reglib memory.cm memory.cm ml-nlffi-lib/memory
668            reglib c-int.cm c-int.cm ml-nlffi-lib/internals
669            reglib c.cm c.cm ml-nlffi-lib
670            ;;
671          pgraph-util)
672            unpack "CM source code" $SRCDIR cm cm
673            reglib pgraph-util.cm pgraph-util.cm cm/pgraph
674            ;;
675          mlrisc-tools)
676            unpack "MLRISC Tools Library" $SRCDIR MLRISC MLRISC
677            reglib mlrisc-tools pp.cm MLRISC/Tools
678            reglib mlrisc-tools source-map.cm MLRISC/Tools
679            reglib mlrisc-tools sml-ast.cm MLRISC/Tools
680            reglib mlrisc-tools prec-parser.cm MLRISC/Tools
681            reglib mlrisc-tools parser.cm MLRISC/Tools
682            reglib mlrisc-tools match-compiler.cm MLRISC/Tools
683            ;;
684          nowhere)
685            echo standalone nowhere NoWhere . MLRISC/Tools >>$LATESTANDALONES
686            echo nowhere $TOOLDIR >>$CM_PATHCONFIG_DEFAULT
687          ;;          ;;
688        doc)        doc)
689          unpack Doc $ROOT doc $ROOT/$VERSION-doc          unpack Doc $ROOT doc doc
690          cd $ROOT/doc          cd $ROOT/doc
691          build $ROOT          build $ROOT
692          ;;          ;;
693        *)        *)
694          echo "!!! Unknown target $i."          echo "$this: !!! Unknown target $i."
695          ;;          ;;
696      esac      esac
697  done  done
# Line 444  Line 702 
702  # $SRCDIR, so we must consult $LOCALPATHCONFIG.  # $SRCDIR, so we must consult $LOCALPATHCONFIG.
703  #  #
704    
705  echo Compiling library code.  echo $this: Compiling library code.
706  echo 'then OS.Process.success else OS.Process.failure);' >>$LIBLIST  echo 'then OS.Process.success else OS.Process.failure));' >>$LIBLIST
707  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then
708      echo Libraries compiled successfully.      echo $this: Libraries compiled successfully.
709  else  else
710      echo "!!! Something went wrong when compiling the libraries."      echo "$this: !!! Something went wrong when compiling the libraries."
711      exit 1      exit 1
712  fi  fi
 rm -f $LIBLIST $LOCALPATHCONFIG  
713    
714  #  #
715  # Finally, move the libraries to their final locations...  # Move the libraries to their final locations...
716  #  #
717    
718  if [ -r $LIBMOVESCRIPT ] ; then  if [ -r $LIBMOVESCRIPT ] ; then
719      echo Moving libraries to $LIBDIR.      echo $this: Moving libraries to $LIBDIR.
720      . $LIBMOVESCRIPT      . $LIBMOVESCRIPT
     rm -f $LIBMOVESCRIPT  
721  fi  fi
722    
723    #
724    # Build "late" standalone programs (i.e., those that must be built
725    # after libraries are already in place):
726    #
727    
728    if [ -r $LATESTANDALONES ] ; then
729        echo $this: Building late standalone programs.
730        . $LATESTANDALONES
731    fi
732    
733    #
734    # Finally, remove duplicate entries from pathconfig file...
735    #
736    if [ -f $CM_PATHCONFIG_DEFAULT ] ; then
737        cp $CM_PATHCONFIG_DEFAULT $PCEDITTMP
738        rm -f $CM_PATHCONFIG_DEFAULT
739        awk <$PCEDITTMP 'NF == 2 { mapping[$1] = $2 }
740    NF != 2 { print $0 }
741    END { for (i in mapping) print i, mapping[i] }' \
742          | sort >$CM_PATHCONFIG_DEFAULT
743    fi
744    
745    exit 0

Legend:
Removed from v.489  
changed lines
  Added in v.1038

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0